###########################################################################
## THIS FILE CONSTRUCT THE SPI-SPEI INDECES FOR MALAWI'S PAPER           ##
## IT USES TXT FILES GENERATED IN THE STATA FILE 2000_****.DTA AND       ##
## IT EXPORTS THE SPI-SPEI INDECES TO BE USED IN STATA 2000_**.DTA FILE  ##
###########################################################################
wichita <- read.csv("~/R/R-3.6.0/library/SPEI/data/wichita.txt", sep="")
library(devtools)
#install_github('sbegueria', 'SPEI')
library(spi)
library(SPEI)
library(data.table)
library(foreign)
install.packages("tidyverse")
library(tidyverse)
install.packages("tidyselect")
library(tidyselect)

spi1 <- spi(wichita$PRCP,1)
View(spi1)
summary(spi1)
plot(spi1)

#balance has data of Precipitation - Evapotranspiration
data(balance) 
names(balance)
bal_spei12 <- spei(balance,12) 
plot(bal_spei12)

bal_spi1 <- spi(balance,1)
View(bal_spi1)
summary(bal_spi1)
plot(bal_spi1)

pre_pet_cru <- read.delim("U:/PSE-Proposal Malaria and paper/WORK V2/PRE_PET_CRU_monthly.txt")
pre_cru <- read.delim("U:/PSE-Proposal Malaria and paper/WORK V2/PRE_CRU_monthly.txt")
pre_chrips <- read.delim("U:/PSE-Proposal Malaria and paper/WORK V2/PRE_CHRIPS_monthly.txt")
chrips_modis <- read.delim("U:/PSE-Proposal Malaria and paper/WORK V2/CHRIPS_MODIS_monthly.txt")

#SPEI CRU
spei3_cru   <- spei(pre_pet_cru,3,ref.start=c(1970,1))
spei6_cru   <- spei(pre_pet_cru,6,ref.start=c(1970,1))
spei12_cru   <- spei(pre_pet_cru,12,ref.start=c(1970,1))
spei24_cru   <- spei(pre_pet_cru,24,ref.start=c(1970,1))

spei3_cru_fitted<-data.frame(spei3_cru$fitted)
spei6_cru_fitted<-data.frame(spei6_cru$fitted)
spei12_cru_fitted<-data.frame(spei12_cru$fitted)
spei24_cru_fitted<-data.frame(spei24_cru$fitted)

write.dta(spei3_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spei3_cru_fitted.dta")
write.dta(spei6_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spei6_cru_fitted.dta")
write.dta(spei12_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spei12_cru_fitted.dta")
write.dta(spei24_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spei24_cru_fitted.dta")

#SPI CRU
spi3_cru    <- spi(pre_cru,3,ref.start=c(1970,1))
spi6_cru    <- spi(pre_cru,6,ref.start=c(1970,1))
spi12_cru    <- spi(pre_cru,12,ref.start=c(1970,1))
spi24_cru    <- spi(pre_cru,24,ref.start=c(1970,1))

spi3_cru_fitted<-data.frame(spi3_cru$fitted)
spi6_cru_fitted<-data.frame(spi6_cru$fitted)
spi12_cru_fitted<-data.frame(spi12_cru$fitted)
spi24_cru_fitted<-data.frame(spi24_cru$fitted)

write.dta(spi3_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi3_cru_fitted.dta")
write.dta(spi6_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi6_cru_fitted.dta")
write.dta(spi12_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi12_cru_fitted.dta")
write.dta(spi24_cru_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi24_cru_fitted.dta")

# SPI CHRIPS
spi3_chrips <- spi(pre_chrips,3,ref.start=c(1981,1))
spi6_chrips <- spi(pre_chrips,6,ref.start=c(1981,1))
spi12_chrips <- spi(pre_chrips,12,ref.start=c(1981,1))
spi24_chrips <- spi(pre_chrips,24,ref.start=c(1981,1))

spi3_chrips_fitted<-data.frame(spi3_chrips$fitted)
spi6_chrips_fitted<-data.frame(spi6_chrips$fitted)
spi12_chrips_fitted<-data.frame(spi12_chrips$fitted)
spi24_chrips_fitted<-data.frame(spi24_chrips$fitted)

write.dta(spi3_chrips_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi3_chrips_fitted.dta")
write.dta(spi6_chrips_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi6_chrips_fitted.dta")
write.dta(spi12_chrips_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi12_chrips_fitted.dta")
write.dta(spi24_chrips_fitted, "U:/PSE-Proposal Malaria and paper/WORK V2/spi24_chrips_fitted.dta")

# SPEI CHRIPS+MODIS
# PET according to Thornthwaite
tho <- thornthwaite(chrips_modis$temp_modis_mean1101,lat=chrips_modis[["lat_wgs841101"]][1])
# PET according to Hargreaves
har <- hargreaves(chrips_modis$temp_modis_min1101,chrips_modis$temp_modis_max1101,lat=chrips_modis[["lat_wgs841101"]][1])

mean_names <- vars_select(names(chrips_modis), contains("mean"))
max_names <- vars_select(names(chrips_modis), contains("max"))
min_names <- vars_select(names(chrips_modis), contains("min"))
rain_names <- vars_select(names(chrips_modis), contains("pre_chrips"))
lat_names <- vars_select(names(chrips_modis), contains("lat_wgs84"))

SPEI_THO <-c() #empty 
SPEI_HAR <-c()
SPI_2001_2016 <-c()
SPEI_THO <- data.frame(chrips_modis[c(1:2)]) # fill up with this to have month and year
SPEI_HAR <- data.frame(chrips_modis[c(1:2)])
SPI_2001_2016 <- data.frame(chrips_modis[c(1:2)])

for (i in 1:243) {
  print(mean_names[[i]])
  print(chrips_modis[[lat_names[[i]]]][1])
  
  ################################
  # PET according to Thornthwaite
  ################################
  
  tho <- thornthwaite(chrips_modis[[mean_names[[i]]]],lat=chrips_modis[[lat_names[[i]]]][1])
  # the balance PRE-PET
  pre_pet_tho <- chrips_modis[[rain_names[[i]]]] - tho 
  #SPEI using Thornthwaite
  spei24_tho   <- spei(pre_pet_tho,24,ref.start=c(2001,1))
  SPEI_THO <- cbind(SPEI_THO, data.frame(spei24_tho$fitted))
  names(SPEI_THO)[i+2] <- gsub("pre_chrips", "spei_tho", rain_names[i]) #renaming to keep the district code
  
  #############################
  # PET according to Hargreaves
  #############################
  
  har <- hargreaves(chrips_modis[[min_names[[i]]]],chrips_modis[[max_names[[i]]]],lat=chrips_modis[[lat_names[[i]]]][1])
  # the balance PRE-PET
  pre_pet_har <- chrips_modis[[rain_names[[i]]]] - har 
  #SPEI using Hargreaves
  spei24_har <- spei(pre_pet_har,24,ref.start=c(2001,1))
  SPEI_HAR <- cbind(SPEI_HAR, data.frame(spei24_har$fitted))
  names(SPEI_HAR)[i+2] <- gsub("pre_chrips", "spei_har", rain_names[i]) #renaming to keep the district code
  
  ###############################
  # SPI CHRIPS-only for 2001-2016
  ###############################
  spi24_2001_2016 <- spi(chrips_modis[[rain_names[[i]]]],24,ref.start=c(2001,1))
  SPI_2001_2016 <- cbind(SPI_2001_2016, data.frame(spi24_2001_2016$fitted))
  names(SPI_2001_2016)[i+2] <- gsub("pre_chrips", "spi_chrips_2001_2016", rain_names[i]) #renaming to keep the district code

}

write.dta(SPEI_THO, "U:/PSE-Proposal Malaria and paper/WORK V2/spei24_tho_fitted.dta")
write.dta(SPEI_HAR, "U:/PSE-Proposal Malaria and paper/WORK V2/spei24_har_fitted.dta")
write.dta(SPI_2001_2016, "U:/PSE-Proposal Malaria and paper/WORK V2/spi24_chrips_2001_2016_fitted.dta")


#### TEST J
#mean_names <- regexpr("mean",names(temp_modis))
##To call only those starting with
#mean_int <- names(temp_modis)[test] 
#resu <- matrix(,nrow = 243,ncol = 1)
#resu <-c()
#for (i in mean_names) {
  #resu <- c(resu,mean(temp_modis[,i]))
#  print(mean(temp_modis[,i]))
#}


